# mlflow register models

This is a simple package consisting APIs to register ML models in databricks

Once any notebook in databricks gets created which is predicting, training or validating models. Users would be interested in 
registering the models generated by the notebook. This library provides following methods:

### Starting a ML Run
-- start_ml_run(experiment_id, model_name, model_path, xgb_instance)
```
experiment_id = <experiment run id>
model_name    = <name of the model which you would like to generate>
model_path    = <path of the model file where model will be generated> for e.g. /dbfs/tmp
xgb_instance  = <Instance of xgb> for e.g. xgb = xgboost.XGBRegressor(...)

returns: active_run

Note:- Currently it supports saving and registering xgb models
```

### Get model details from ML run
-- get_model_details(run_id, model_name, artifact_path)
```
run_id        = <run id got from actie run>
model_name    = <name of the model>
artifact_path = <path of the generated artifact. Usually it's the model name itself for e.g. runs:/{run_id}/{artifact_path}>

returns: model_details
```

### Wait until model is ready
--- wait_until_ready(model_name, model_version)
```
model_name     = <model name>
model_vevrsion = <version of the model>

returns: Does not return anything. Simply waits for model to get ready

Note:- Both the above parameters can be obtained from get_model_details method
```

### All the aboe methods can be used in a ML notebook in the end as follows:
```
import mlmodels as ml

active_run = ml.start_ml_run("111111111", "xyz", "/dbsfs/tmp/xyz/xyz.model", xgb)
model_details = ml.get_model_details(active_run.info.run_id, "xyz", "xyz")
ml.wait_until_ready(model_details.name, model_details.version)
```
